/*
 * Created on Mar 12, 2005
 * Created by omschaub for kazgor
 * 
 */
package kazgorColumn;



import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.ColorDialog;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Text;
import org.gudy.azureus2.plugins.PluginConfig;
import org.gudy.azureus2.plugins.PluginInterface;
import org.gudy.azureus2.ui.swt.plugins.UISWTPluginView;


public class View extends UISWTPluginView {
    
    //The current Display
    private static Display display;
    
    //This view main GUI object
    private Composite composite;
    

    //The Plugin interface
    private PluginInterface pluginInterface;
    
    private Button first_priority, ignore_rules, manual_set;
    private Label manual_label1, manual_label2;
    private Text input_text;
    
    //The Static Plugin interface, will describe in more details later
    private static PluginInterface pi_static;
    
    
    //We will be using a plugin config a LOT, so instead of calling one each time,
    //lets set up a global one
    private PluginConfig pluginConfig;
    
  public View(PluginInterface pluginInterface) {
    this.pluginInterface = pluginInterface;
      
  }
    
    /**
     * The Plugin name, as it'll be seen within the Plugins Menu in azureus
     */
    public String getPluginViewName() {
        return "ExtraColumns";
    }
    
    /**
     * The plugin Title, used for its Tab name in the main window
     */
    public String getFullTitle() {      
        return "ExtraColumns";
    }
    
    /**
     * Here is the GUI initialization
     */
    public void initialize(Composite parent) {
        
        // We store the Display variable as we'll need it for async GUI Changes
        display = parent.getDisplay();

        //For static calls -- we will use a static pluginInterface
        //make it private and make a call for it below the end of the initialize
        pi_static = pluginInterface;
     
     
        //we need to initialize the global pluginConfig
        pluginConfig = pluginInterface.getPluginconfig();
        
        //main composite layout -- we need to first set up a composite 
        //( a composite is like a chalk board to draw everything on)
        this.composite = new Composite(parent,SWT.NULL);

        //For this composite we will be using a grid layout -- much better than a form layout :)
        GridLayout layout = new GridLayout();
        
        //Specify the number of columns on the composite
        layout.numColumns = 2;
        
        
        //Tell the composite to use the layout
        composite.setLayout(layout);
        
        //And now some GridData to tell it what to do on the parent composite
        GridData gridData = new GridData(GridData.FILL_BOTH);
        composite.setLayoutData(gridData);
        
        //make a new Group to put the color composits in
        final Group color_group = new Group(composite,SWT.NULL);
        color_group.setLayout(new GridLayout(2,false));
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
        gridData.horizontalSpan = 2;
        color_group.setLayoutData(gridData);
        
        //Make a button to select the first color 
        Button color_chooser_1 = new Button(color_group, SWT.PUSH);
        //Set the text of the button
        color_chooser_1.setText("Choose the color for 75% to 100%");
        
        
        //To be cute here, we will draw a label and set it as a image Label and draw a rectangle with the current color!  Cute, huh :)
        final Label color_label_1 = new Label(color_group,SWT.BORDER);
        
        //Set its grid data
        gridData = new GridData(GridData.BEGINNING);
        color_label_1.setLayoutData(gridData);
        color_label_1.setImage(DrawImage.labelColor("color75_100",200,0,0));
        
        
        //Now we need to add a listener to the button to listen for it being pushed
        //The listeners ALWAYS use this form
        color_chooser_1.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                //Insert code here to run when button is pushed
                
                //define color dialog -- needs to be drawn on a shell
                ColorDialog colorDialog1 = new ColorDialog(color_group.getShell());
                
                //Set the title for the color dialog
                colorDialog1.setText("Choose the color for 75% to 100%");
                
                //Set the inital color to the user specified color and if that does
                //not work, then a default color is chosen
                //This will be a little lengthy because the Azureus core settings 
                //does not have a int array, just an integer, so we will have to 
                //make 3 each time -- we will default the first color to 200,0,0
                colorDialog1.setRGB((new RGB(
                        pluginConfig.getPluginIntParameter("color75_100_RED", 200),
                        pluginConfig.getPluginIntParameter("color75_100_GREEN",0),
                        pluginConfig.getPluginIntParameter("color75_100_BLUE",0))));
                
                //open the dialog and set the results to a new RGB color
                RGB selectedColor = colorDialog1.open();
                
                //if cancel is hit then the selectedColor will be null and we need to break
                //out of the listener
                if(selectedColor==null)
                    return;
                
                
                //set the defaults to the new RGB color so that the columns can pick it up
                pluginConfig.setPluginParameter("color75_100_RED",selectedColor.red);
                pluginConfig.setPluginParameter("color75_100_GREEN",selectedColor.green);
                pluginConfig.setPluginParameter("color75_100_BLUE",selectedColor.blue);
                
                //now we need to redraw the label
                color_label_1.setImage(DrawImage.labelColor("color75_100",200,0,0));
                
            }
        });
 
        
        /**EVERYTHING FROM HERE ON TO THE END IS A COPY AND PASTE BUT CHANGING THE PARAMATERS*/
        
        
//      Make a button to select the first color 
        Button color_chooser_2 = new Button(color_group, SWT.PUSH);
        //Set the text of the button
        color_chooser_2.setText("Choose the color for 50% to 75%  ");    
        
        //To be cute here, we will draw a label and set it as a image Label and draw a rectangle with the current color!  Cute, huh :)
        final Label color_label_2 = new Label(color_group,SWT.BORDER);
        
        //Set its grid data
        gridData = new GridData(GridData.BEGINNING);
        color_label_2.setLayoutData(gridData);
        color_label_2.setImage(DrawImage.labelColor("color50_75",255,128,64));
        
        
        //Now we need to add a listener to the button to listen for it being pushed
        //The listeners ALWAYS use this form
        color_chooser_2.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                //Insert code here to run when button is pushed
                
                //define color dialog -- needs to be drawn on a shell
                ColorDialog colorDialog2 = new ColorDialog(color_group.getShell());
                
                //Set the title for the color dialog
                colorDialog2.setText("Choose the color for 50% to 75%  ");             
                //Set the inital color to the user specified color and if that does
                //not work, then a default color is chosen
                //This will be a little lengthy because the Azureus core settings 
                //does not have a int array, just an integer, so we will have to 
                //make 3 each time -- we will default the first color to 200,0,0
                colorDialog2.setRGB((new RGB(
                        pluginConfig.getPluginIntParameter("color50_75_RED", 255),
                        pluginConfig.getPluginIntParameter("color50_75_GREEN",128),
                        pluginConfig.getPluginIntParameter("color50_75_BLUE",64))));
                
                //open the dialog and set the results to a new RGB color
                RGB selectedColor = colorDialog2.open();

                //if cancel is hit then the selectedColor will be null and we need to break
                //out of the listener
                if(selectedColor==null)
                    return;
                
                
                //set the defaults to the new RGB color so that the columns can pick it up
                pluginConfig.setPluginParameter("color50_75_RED",selectedColor.red);
                pluginConfig.setPluginParameter("color50_75_GREEN",selectedColor.green);
                pluginConfig.setPluginParameter("color50_75_BLUE",selectedColor.blue);
                
                //now we need to redraw the label
                color_label_2.setImage(DrawImage.labelColor("color50_75",255,128,64));
                
            }
        });
        
//      Make a button to select the first color 
        Button color_chooser_3 = new Button(color_group, SWT.PUSH);
        //Set the text of the button
        color_chooser_3.setText("Choose the color for 25% to 50%  ");
        
        
        //To be cute here, we will draw a label and set it as a image Label and draw a rectangle with the current color!  Cute, huh :)
        final Label color_label_3 = new Label(color_group,SWT.BORDER);
        
        //Set its grid data
        gridData = new GridData(GridData.BEGINNING);
        color_label_3.setLayoutData(gridData);
        color_label_3.setImage(DrawImage.labelColor("color25_50",0,128,255));
        
        
        //Now we need to add a listener to the button to listen for it being pushed
        //The listeners ALWAYS use this form
        color_chooser_3.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                //Insert code here to run when button is pushed
                
                //define color dialog -- needs to be drawn on a shell
                ColorDialog colorDialog3 = new ColorDialog(color_group.getShell());
                
                //Set the title for the color dialog
                colorDialog3.setText("Choose the color for 25% to 50%  ");
                
                //Set the inital color to the user specified color and if that does
                //not work, then a default color is chosen
                //This will be a little lengthy because the Azureus core settings 
                //does not have a int array, just an integer, so we will have to 
                //make 3 each time -- we will default the first color to 200,0,0
                colorDialog3.setRGB((new RGB(
                        pluginConfig.getPluginIntParameter("color25_50_RED", 0),
                        pluginConfig.getPluginIntParameter("color25_50_GREEN",128),
                        pluginConfig.getPluginIntParameter("color25_50_BLUE",255))));
                
                //open the dialog and set the results to a new RGB color
                RGB selectedColor = colorDialog3.open();

                //if cancel is hit then the selectedColor will be null and we need to break
                //out of the listener
                if(selectedColor==null)
                    return;
                
                
                //set the defaults to the new RGB color so that the columns can pick it up
                pluginConfig.setPluginParameter("color25_50_RED",selectedColor.red);
                pluginConfig.setPluginParameter("color25_50_GREEN",selectedColor.green);
                pluginConfig.setPluginParameter("color25_50_BLUE",selectedColor.blue);
                
                //now we need to redraw the label
                color_label_3.setImage(DrawImage.labelColor("color25_50",0,128,255));
                
            }
        });
//      Make a button to select the first color 
        Button color_chooser_4 = new Button(color_group, SWT.PUSH);
        //Set the text of the button
        color_chooser_4.setText("Choose the color for 0% to 25%    ");    
		   
        //To be cute here, we will draw a label and set it as a image Label and draw a rectangle with the current color!  Cute, huh :)
        final Label color_label_4 = new Label(color_group,SWT.BORDER);
        
        //Set its grid data
        gridData = new GridData(GridData.BEGINNING);
        color_label_4.setLayoutData(gridData);
        color_label_4.setImage(DrawImage.labelColor("color0_25",64,0,128));
        
        
        //Now we need to add a listener to the button to listen for it being pushed
        //The listeners ALWAYS use this form
        color_chooser_4.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                //Insert code here to run when button is pushed
                
                //define color dialog -- needs to be drawn on a shell
                ColorDialog colorDialog4 = new ColorDialog(color_group.getShell());
                
                //Set the title for the color dialog
				colorDialog4.setText("Choose the color for 0% to 25%    ");
                
                //Set the inital color to the user specified color and if that does
                //not work, then a default color is chosen
                //This will be a little lengthy because the Azureus core settings 
                //does not have a int array, just an integer, so we will have to 
                //make 3 each time -- we will default the first color to 200,0,0
                colorDialog4.setRGB((new RGB(
                        pluginConfig.getPluginIntParameter("color0_25_RED", 64),
                        pluginConfig.getPluginIntParameter("color0_25_GREEN",0),
                        pluginConfig.getPluginIntParameter("color0_25_BLUE",128))));
                
                //open the dialog and set the results to a new RGB color
                RGB selectedColor = colorDialog4.open();

                //if cancel is hit then the selectedColor will be null and we need to break
                //out of the listener
                if(selectedColor==null)
                    return;
                
                
                //set the defaults to the new RGB color so that the columns can pick it up
                pluginConfig.setPluginParameter("color0_25_RED",selectedColor.red);
                pluginConfig.setPluginParameter("color0_25_GREEN",selectedColor.green);
                pluginConfig.setPluginParameter("color0_25_BLUE",selectedColor.blue);
                
                //now we need to redraw the label
                color_label_4.setImage(DrawImage.labelColor("color0_25",64,0,128));
                
            }
        });
        
        Group settings_group = new Group (composite,SWT.NULL);
        settings_group.setText("Base upload ratio on...");
        settings_group.setLayout(new GridLayout(2,false));

	    long setting = this.pluginInterface.getPluginconfig().getIntParameter("StartStopManager_iFirstPriority_ShareRatio",1000);
        float float_temp =  (float)setting / 1000;		
        first_priority = new Button(settings_group,SWT.RADIO);
        first_priority.setText("First Priority --> A share ratio under... ("+float_temp+":1)");
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
        gridData.horizontalSpan = 2;
        first_priority.setLayoutData(gridData);
        first_priority.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                pluginConfig.setPluginParameter("ratio_type",1);
            }
        });

        float float_temp2 =this.pluginInterface.getPluginconfig().getFloatParameter("Stop Ratio"); 
        ignore_rules = new Button(settings_group,SWT.RADIO);
        ignore_rules.setText("Ignore Rules --> Ignore torrents that have share ratio under... ("+float_temp2+":1)");
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
        gridData.horizontalSpan = 2;
        ignore_rules.setLayoutData(gridData);
        ignore_rules.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                pluginConfig.setPluginParameter("ratio_type",2);
                
            }
        });
        
        
        manual_set = new Button(settings_group,SWT.RADIO);
        manual_set.setText("Manually set ratio");
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
        gridData.horizontalSpan = 2;
        manual_set.setLayoutData(gridData);
        manual_set.addListener(SWT.Selection, new Listener() {
            public void handleEvent(Event e) {
                if(manual_set.getSelection()){
                    enableManualRatio(true);
                    pluginConfig.setPluginParameter("ratio_type",3);
                }else{
                    enableManualRatio(false);
                }
            }
        });
        
        int type = pluginConfig.getPluginIntParameter("ratio_type",2);
        if(type == 1){
            first_priority.setSelection(true);
        }else if(type == 3){
            manual_set.setSelection(true);
        }else{
            ignore_rules.setSelection(true);
        }
        
        Composite ratio_comp = new Composite(settings_group,SWT.NULL);
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_END);
        gridData.horizontalSpan = 1;
        ratio_comp.setLayoutData(gridData);
        
        GridLayout gridLayout = new GridLayout();
        gridLayout.numColumns = 3;
        //gridLayout.marginTop = 0;
        //gridLayout.marginBottom = 0;
        ratio_comp.setLayout(gridLayout);
        
        manual_label1 = new Label(ratio_comp,SWT.NULL);
        manual_label1.setText("           Ratio of");
        
        input_text = new Text(ratio_comp,SWT.BORDER | SWT.SINGLE | SWT.RIGHT);
        input_text.setText(pluginConfig.getPluginStringParameter("manual_ratio", "2"));
        gridData = new GridData(GridData.HORIZONTAL_ALIGN_BEGINNING);
        gridData.widthHint = 30;
        input_text.setLayoutData(gridData);
           
        //make sure people only put in numbers!
        input_text.addListener (SWT.Verify, new Listener () {
            public void handleEvent (Event e) {
                String string = e.text;
                char [] chars = new char [string.length ()];
                string.getChars (0, chars.length, chars, 0);
                for (int i=0; i<chars.length; i++) {
                    if (!('0' <= chars [i] && chars [i] <= '9')) {
                        if(chars[i] != '.'){
                            e.doit = false;
                            return;
                        }
                    }
                }
            }
        });
        
        //listen for changes in the text
        input_text.addListener(SWT.Modify,new Listener() {

            public void handleEvent(Event arg0) {
                pluginConfig.setPluginParameter("manual_ratio",input_text.getText());
                
            }
           
            
        });
        
        manual_label2 = new Label(ratio_comp,SWT.NULL);
        manual_label2.setText(":1");
        
        if(!manual_set.getSelection()){
           enableManualRatio(false);
        }
    }
    
    
    /**
     * This method will be called after initialization, in order to grab this
     * view composite.  This call is critical for the plugin GUI to funciton correctly
     */
    public Composite getComposite() {
        return this.composite;
    }
    
    
    //These next two calls I use because there is no way to 'get' the display and 
    //pluginInterface from the view so you have to make your own public calls.. 
    //I like static calls, so I can call without initializing
    
    
    /**
     * Call for returning the display -- used in the DrawImage to get the working display
     * 
     */
    public static Display getDisplay() {
        return display;
    }
    
    
    /**
     * Call for pluginInterface from view
     */
    public static PluginInterface getPluginInterface(){
        return pi_static;
    }
    
    /**
     * Little method to turn on and off the manually set ratio
     */
    public void enableManualRatio(final boolean hide){
        if(display == null || display.isDisposed())
            return;
        
        display.asyncExec( new Runnable() {
            public void run() {
                manual_label1.setEnabled(hide);
                input_text.setEnabled(hide);
                manual_label2.setEnabled(hide);        
            }
        });
        
        
    }
    
    
    
    
}
